<?php
################################################################################
# @Name : searchengine_ticket.php
# @Desc : search engine in database tickets
# @call : /dashboard.php
# @parameters : keywords
# @Author : Flox
# @Create : 12/01/2011
# @Update : 11/02/2016
# @Version : 3.1.6
################################################################################

//initialize session variables
if(!isset($_SESSION['user_id'])) $_SESSION['user_id'] = '';

//case when keywords contain '
$keywords = str_replace("'","\'",$keywords);

//keywords table space separation
$keyword=explode(" ",$keywords);

//count $keywords
$nbkeyword= sizeof($keyword);

if ($nbkeyword>1) {
	$from = "
	FROM tincidents
	LEFT JOIN tthreads ON tthreads.ticket = tincidents.id
	AND tthreads.date = (SELECT tthreads.date FROM tthreads WHERE tthreads.ticket = tincidents.id ORDER BY date DESC LIMIT 0,1)
	AND (
	";
	for ($i=0; $i<$nbkeyword; $i++) {
		$from.= "
		tthreads.date LIKE '%".$keyword[$i]."%'
		";
		if ($i<$nbkeyword-1) $from.= "OR";
	}
	$from.= "
	)
	, tstates
	";
	if($rparameters['ticket_places']==1){
		$from.= ", tplaces ";
	}
	$from.="
	WHERE tincidents.state=tstates.id
	";
	if($rparameters['ticket_places']==1){
		$from.= "
		AND tincidents.place=tplaces.id
		AND tplaces.id LIKE '$_POST[place]'
		";
	}
	$from.= "
	AND tincidents.state=tstates.id
	AND (
	";
	for ($i=0; $i<$nbkeyword; $i++) {
		$from.= "
		(
			tincidents.title LIKE '%".$keyword[$i]."%' OR 
			tincidents.description LIKE '%".$keyword[$i]."%' OR 
			tincidents.user LIKE (SELECT max(id) FROM tusers where firstname LIKE '%".$keyword[$i]."%' or lastname LIKE '%".$keyword[$i]."%') 
		)
		";
		if ($i<$nbkeyword-1) $from.= "OR";
	}
	$from.= "
	)
	AND disable='0'
	"; 
} else {
	$from = "
	FROM tincidents
	LEFT JOIN tthreads ON tthreads.ticket = tincidents.id
	AND tthreads.date = (SELECT tthreads.date FROM tthreads WHERE tthreads.ticket = tincidents.id ORDER BY date DESC LIMIT 0,1)
	AND tthreads.date LIKE '%".$keyword[$nbkeyword-1]."%'
	, tstates, tsubcat, tcategory 
	";
	if($rparameters['ticket_places']==1){
		$from.= ", tplaces ";
	}
	$from.="
	WHERE tincidents.state=tstates.id
	";
	if($rparameters['ticket_places']==1){
		$from.= "
		AND tincidents.place=tplaces.id
		AND tplaces.id LIKE '$_POST[place]'
		";
	}
	$from.= "
	AND tincidents.state=tstates.id
	AND tincidents.subcat=tsubcat.id
	AND tincidents.category=tcategory.id
	AND (
		tincidents.title LIKE '%".$keyword[$nbkeyword-1]."%' OR 
		tincidents.description LIKE '%".$keyword[$nbkeyword-1]."%' OR 
		tsubcat.name LIKE '".$keyword[$nbkeyword-1]."' OR
		tcategory.name LIKE '".$keyword[$nbkeyword-1]."' OR
		tincidents.id = '".$keyword[$nbkeyword-1]."' OR
		tincidents.user LIKE (SELECT max(id) FROM tusers where firstname LIKE '%".$keyword[$nbkeyword-1]."%' or lastname LIKE '%".$keyword[$nbkeyword-1]."%')
	)
	AND disable='0'
"; 
	
}	
?>
